/*
 * XMLAddress.java
 * @author  ashur
 * @version 
 */


/**
 * In order to use the XML parser, you will need to download JAXP from the sun
 * site and add XALAN.JAR to your classpath
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.text.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.tree.TreeSelectionModel;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JFrame;

import javax.xml.parsers.*; 
import java.net.*;
import java.io.*;
import java.util.*;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;


public class XMLAddress  extends JFrame implements ActionListener                             
{  
     /**
      * Define Vars to be used in createSendingXML 
     */ 
      String sHttpAddress = "";
      String sCustID = "";
      String sPhone = "";
      String sFullName = "";
      String sCompany = "";
      String sAddress = "";
      String sAddress2 = "";
      String sSuite = "";
      String sCity = "";
      String sState = "";
      String sZip = "";
      String sPlus4 = "";
      
      /**
       * These will be used for building the GUI
       */
      Document document;
      JSplitPane splitPane;
      JSplitPane LeftPane;
      JPanel LeftPaneTop;
      JPanel LeftPaneBottom;
      JScrollPane RightPane;
      
      /** This is a path to the location of a temp file which will hold the returned XML Doc */
       
      String sFilePath = "C:\\Temp\\XMLInput.xml";
      
    
    /** Creates new XMLAddress */
    public Component XMLAddress() 
    {

        LeftPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
        LeftPaneTop = new JPanel();
        LeftPaneBottom = new JPanel();
        
        /** Set the Buttons */
        JButton b_Execute = new JButton("Execute");
        JButton b_Clear = new JButton("Clear");
        JButton b_Exit = new JButton("Exit");
        
        /** Set the Labels */
        JLabel l_httpAddress = new JLabel("http address: ");
        JLabel l_CustID = new JLabel("Customer ID: ");
        JLabel l_Phone = new JLabel("Phone:       ");
        JLabel l_FullName = new JLabel("Full Name:   ");
        JLabel l_Company = new JLabel("Company:    ");
        JLabel l_Address = new JLabel("Address:    ");
        JLabel l_Address2 = new JLabel("Address2:    ");
        JLabel l_Suite = new JLabel("Suite:    ");
        JLabel l_City = new JLabel("City:    ");
        JLabel l_State = new JLabel("State:    ");
        JLabel l_Zip = new JLabel("Zip:    ");
        JLabel l_ZipPlusFour = new JLabel("Zip+4:    ");
        JLabel l_spacing = new JLabel("                            ");
        
        /** Set the Text Field Names and initialize where desired */
        final JTextField t_httpAddress = new JTextField("http://xml.melissadata.com/xml.asp", 30);
        final JTextField t_CustID = new JPasswordField("");
        final JTextField t_Phone = new JTextField(10);
        final JTextField t_FullName = new JTextField(10);
        final JTextField t_Company = new JTextField(10);
        final JTextField t_Address = new JTextField(10);
        final JTextField t_Address2 = new JTextField(10);
        final JTextField t_Suite = new JTextField(10);
        final JTextField t_City = new JTextField(10);
        final JTextField t_State = new JTextField(10);
        final JTextField t_Zip = new JTextField(10);
        final JTextField t_Plus4 = new JTextField(10);
     
        LeftPane.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Input/Get Values"));
        
        /** Using GridBagLayout for GUI */
        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();        
        
        LeftPaneTop.setLayout(gridbag);
        c.gridwidth = GridBagConstraints.HORIZONTAL;
        c.fill = GridBagConstraints.HORIZONTAL;
        
        LeftPaneBottom.setLayout(new GridLayout(1,3));
        LeftPane.setDividerLocation(300);
        
        /** Create arrays of text & Label fields, will be passed to addLabelTextRows function */
        final JTextField[] textFields = {t_httpAddress, t_CustID, t_Phone, t_FullName, t_Company, t_Address, t_Address2, t_Suite, t_City, t_State, t_Zip, t_Plus4};
        JLabel[] labels = {l_httpAddress, l_CustID, l_Phone, l_FullName, l_Company, l_Address, l_Address2, l_Suite, l_City, l_State, l_Zip, l_ZipPlusFour};
        addLabelTextRows(labels, textFields, gridbag, LeftPaneTop);
       
       /** add the buttons */
        LeftPaneBottom.add(b_Execute);
        LeftPaneBottom.add(b_Clear);
        LeftPaneBottom.add(b_Exit);
       
        LeftPane.setTopComponent(LeftPaneTop);
        LeftPane.setBottomComponent(LeftPaneBottom);
       
        /** Create the scroll pane */
        RightPane = new JScrollPane();

        /** Add the scroll panes to a split pane. */
        splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
        splitPane.setLeftComponent(LeftPane);
        splitPane.setRightComponent(RightPane);
        
        /** Set the sizing */
        Dimension minimumSize = new Dimension(300, 250);
        RightPane.setMinimumSize(minimumSize);
        splitPane.setDividerLocation(350); 
        splitPane.setPreferredSize(new Dimension(700, 350));
        
  /** If Execute button pressed... */      
  b_Execute.setMnemonic(KeyEvent.VK_I);
  b_Execute.addActionListener(new ActionListener() 
  {
    public void actionPerformed(ActionEvent e) 
    {
      //Read in the Input Variables before call createSendingXML 
      sHttpAddress = t_httpAddress.getText();
      sCustID = t_CustID.getText();
      sPhone = t_Phone.getText();
      sFullName = t_FullName.getText();
      sCompany = t_Company.getText();
      sAddress = t_Address.getText();
      sAddress2 = t_Address2.getText();
      sSuite = t_Suite.getText();
      sCity = t_City.getText();
      sState = t_State.getText();
      sZip = t_Zip.getText();
      sPlus4 = t_Plus4.getText();
    
      String xmldata = createSendingXML();
      
      String param = xmldata;
      URL url;
      try
      {
        /** Set the URL with what was entered in the GUI */  
        url = new URL (sHttpAddress);
        
        /** Establish the connection */
        HttpURLConnection urlConn = (HttpURLConnection)url.openConnection();
        urlConn.setDoInput (true);
        urlConn.setDoOutput (true);
        urlConn.setUseCaches (false);
        urlConn.setRequestMethod("POST");
        urlConn.setRequestProperty("Accept-Language","en");
        urlConn.setAllowUserInteraction(false);
        urlConn.setRequestProperty("Content-length",String.valueOf(param.length()));    
        urlConn.setRequestProperty("Content-Type","application/x-www-form-urlencoded");
        DataOutputStream out=new DataOutputStream(urlConn.getOutputStream());
        out.writeBytes(param);
        out.flush();
        out.close();


        BufferedReader in = new BufferedReader(new InputStreamReader(urlConn.getInputStream()));
        String inputLine = "";
        while ((inputLine = in.readLine()) != null)
        {
        inputLine = in.readLine();

        try
        {
            /** Write to temp File */
            FileWriter newFile = new FileWriter(sFilePath);
            newFile.write(inputLine);
            newFile.flush();
            newFile.close();
        }
        catch(IOException ioe)
        {
            System.out.println(ioe);
        }
        }
        /** Call CreateDOM method which will retrieve from the temp file... */
        createDOM();
        /** Set up the tree */
        addTree();
        in.close();
        /** Close the connection */
        urlConn.disconnect();
            
      }//end try
      catch (MalformedURLException err)
      {
         System.out.println("Error: " + err);
         return;
      }   
      catch (IOException err)
      {
         System.out.println("Error: " + err);
         return;
      }

    
    }//end action performed
});

b_Clear.addActionListener(new ActionListener() 
{
    public void actionPerformed(ActionEvent e) 
    {
        /** Set to 1 because want to leave httpAddress */
        for(int i=1; i < 12; i++)
        {
            textFields[i].setText("");
        }
    }
});
 
b_Exit.addActionListener(new ActionListener() 
{
    public void actionPerformed(ActionEvent e) 
    {
       System.exit(0);
    }
});

        
     return splitPane;
    
}

/** Parses the XML based on the Temp file written to above */
public void createDOM()  
{
 
    try 
    {
       
        DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
	DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
        document = docBuilder.parse(new File (sFilePath));
        
        // normalize text representation
	document.getDocumentElement ().normalize ();
        //System.out.println ("Root element of the doc is " + document.getDocumentElement().getNodeName());
    }
    catch (SAXParseException err) 
    {
	    System.out.println ("** Parsing error" + ", line " + err.getLineNumber () + ", uri " + err.getSystemId ());
	    System.out.println("   " + err.getMessage ());
	    // print stack trace as below
    }
    catch (SAXException e) 
    {
	Exception x = e.getException ();
        ((x == null) ? e : x).printStackTrace ();

    }
    catch (Throwable t) 
    {
	    t.printStackTrace ();
    }
    
  return;
}

/** Creates the tree which is added to the Right Pane */
private void addTree()
{
        /** Create a tree that allows one selection at a time.
         *  Is based on class we create.
         */
        JTree tree = new JTree(new DomToTreeModelAdapter());
               
        //final JTree tree = new JTree(top);
        tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);       
       
        RightPane = new JScrollPane(tree);
        splitPane.setRightComponent(RightPane);
    
}

/**
 * Adds Labels and rows to the Grid bag
 */
private void addLabelTextRows(JLabel[] labels, JTextField[] textFields, GridBagLayout gridbag, Container container) 
{
        GridBagConstraints c = new GridBagConstraints();
        c.anchor = GridBagConstraints.EAST;
        int numLabels = labels.length;

        for (int i = 0; i < numLabels; i++) 
        {
            c.gridwidth = GridBagConstraints.RELATIVE; //next-to-last
            c.fill = GridBagConstraints.NONE;      //reset to default
            c.weightx = 0.0;                       //reset to default
            gridbag.setConstraints(labels[i], c);
            container.add(labels[i]);

            c.gridwidth = GridBagConstraints.REMAINDER;     //end row
            c.fill = GridBagConstraints.BOTH;
            c.weightx = 1.0;
            gridbag.setConstraints(textFields[i], c);
            container.add(textFields[i]);
        }
}

/**
 * Creates XML that will be sent to the server
 */
private String createSendingXML()
{
	String xmlstr = "<?xml version=\"1.0\"?>";		

	xmlstr += "<RecordSet>";
	xmlstr += "<CustomerID>"; 
	xmlstr += sCustID;
	xmlstr += "</CustomerID>";
        /* 
         * If wanted to check multiple addresses, could insert a loop here
         * Close loop just before </RecordSed> tag
        */
        xmlstr += "<Record>";
        xmlstr += "<CustRecNo>";
        xmlstr += "1235488";
        xmlstr += "</CustRecNo>";
        xmlstr += "<Address>";	/** w/o address then no address information are returned */
        xmlstr += sAddress;
        xmlstr += "</Address>";
        xmlstr += "<Address2>";
        xmlstr += sAddress2;
        xmlstr += "</Address2>";
        xmlstr += "<City>";
        xmlstr += sCity;
        xmlstr += "</City>";
        xmlstr += "<State>";
        xmlstr += sState;
        xmlstr += "</State>";
        xmlstr += "<Zip>";
        xmlstr += sZip;
        xmlstr += "</Zip>";
        xmlstr += "<Plus4>";
        xmlstr += sPlus4;
        xmlstr += "</Plus4>";
        xmlstr += "<AddressTypeString>";
        xmlstr += "</AddressTypeString>";
        xmlstr += "<CityAbbreviation>";
        xmlstr += "</CityAbbreviation>";
        xmlstr += "<CarrierRoute>";
        xmlstr += "</CarrierRoute>";
        xmlstr += "<DeliveryPointCode>";
        xmlstr += "</DeliveryPointCode>";
        xmlstr += "<DeliveryPointCheckDigit>";
        xmlstr += "</DeliveryPointCheckDigit>";
        xmlstr += "<CountyFips>";
        xmlstr += "</CountyFips>";
        xmlstr += "<CountyName>";
        xmlstr += "</CountyName>";
        xmlstr += "<TimeZone>";
        xmlstr += "</TimeZone>";
        xmlstr += "<TimeZoneCode>";
        xmlstr += "</TimeZoneCode>";
        xmlstr += "<Msa>";
        xmlstr += "</Msa>";
        xmlstr += "<Pmsa>";
        xmlstr += "</Pmsa>";
        xmlstr += "<AreaCodeOfZip>";
        xmlstr += "</AreaCodeOfZip>";
        xmlstr += "<AddressTypeCode>";
        xmlstr += "</AddressTypeCode>";
        xmlstr += "<Lacs>";
        xmlstr += "</Lacs>";
        xmlstr += "<PrivateMailBox>";
        xmlstr += "</PrivateMailBox>";
        xmlstr += "<CongressionalDistrict>";
        xmlstr += "</CongressionalDistrict>";
        xmlstr += "<ParsedAddressRange>";
        xmlstr += "</ParsedAddressRange>";
        xmlstr += "<ParsedPreDirection>";
        xmlstr += "</ParsedPreDirection>";
        xmlstr += "<ParsedStreetName>";
        xmlstr += "</ParsedStreetName>";
        xmlstr += "<ParsedSuffix>";
        xmlstr += "</ParsedSuffix>";
        xmlstr += "<ParsedPostDirection>";
        xmlstr += "</ParsedPostDirection>";
        xmlstr += "<ParsedSuiteName>";
        xmlstr += "</ParsedSuiteName>";
        xmlstr += "<ParsedSuiteRange>";
        xmlstr += "</ParsedSuiteRange>";
        xmlstr += "<ParsedGarbage>";
        xmlstr += "</ParsedGarbage>";
        xmlstr += "<AddressErrorCode>";
        xmlstr += "</AddressErrorCode>";
        xmlstr += "<AddressErrorString>";
        xmlstr += "</AddressErrorString>";
        xmlstr += "<AddressStatusCode>";
        xmlstr += "</AddressStatusCode>";
        xmlstr += "<AddressDatabaseDate>";
        xmlstr += "</AddressDatabaseDate>";
        xmlstr += "<Latitude>";
        xmlstr += "</Latitude>";
        xmlstr += "<Longitude>";
        xmlstr += "</Longitude>";
        xmlstr += "<CensusTract>";
        xmlstr += "</CensusTract>";
        xmlstr += "<CensusBlock>";
        xmlstr += "</CensusBlock>";
        xmlstr += "<GeocodeErrorCode>";
        xmlstr += "</GeocodeErrorCode>";
        xmlstr += "<GeocodeStatusCode>";
        xmlstr += "</GeocodeStatusCode>";
        xmlstr += "<GeocodeDatabaseDate>";
        xmlstr += "</GeocodeDatabaseDate>";
        xmlstr += "<Phone>";
        xmlstr += sPhone;
        xmlstr += "</Phone>";
        xmlstr += "<PhoneAreaCode>";
        xmlstr += "</PhoneAreaCode>";
        xmlstr += "<PhonePrefix>";
        xmlstr += "</PhonePrefix>";
        xmlstr += "<PhoneSuffix>";
        xmlstr += "</PhoneSuffix>";
        xmlstr += "<PhoneExtension>";
        xmlstr += "</PhoneExtension>";
        xmlstr += "<PhoneCity>";
        xmlstr += "</PhoneCity>";
        xmlstr += "<PhoneState>";
        xmlstr += "</PhoneState>";
        xmlstr += "<PhoneDistance>";
        xmlstr += "</PhoneDistance>";
        xmlstr += "<PhoneCountyFips>";
        xmlstr += "</PhoneCountyFips>";
        xmlstr += "<PhoneCountyName>";
        xmlstr += "</PhoneCountyName>";
        xmlstr += "<PhoneLatitude>";
        xmlstr += "</PhoneLatitude>";
        xmlstr += "<PhoneLongitude>";
        xmlstr += "</PhoneLongitude>";
        xmlstr += "<PhoneTimeZone>";
        xmlstr += "</PhoneTimeZone>";
        xmlstr += "<PhoneTimeZoneCode>";
        xmlstr += "</PhoneTimeZoneCode>";
        xmlstr += "<PhoneMsa>";
        xmlstr += "</PhoneMsa>";
        xmlstr += "<PhonePmsa>";
        xmlstr += "</PhonePmsa>";
        xmlstr += "<PhoneCountry>";
        xmlstr += "</PhoneCountry>";
        xmlstr += "<PhoneNewAreaCode>";
        xmlstr += "</PhoneNewAreaCode>";
        xmlstr += "<PhoneErrorCode>";
        xmlstr += "</PhoneErrorCode>";
        xmlstr += "<PhoneStatusCode>";
        xmlstr += "</PhoneStatusCode>";
        xmlstr += "<PhoneDatabaseDate>";
        xmlstr += "</PhoneDatabaseDate>";
        xmlstr += "<FirstName>";
        xmlstr += "</FirstName>";
        xmlstr += "<MiddleName>";
        xmlstr += "</MiddleName>";
        xmlstr += "<LastName>";
        xmlstr += "</LastName>";
        xmlstr += "<NamePrefix>";
        xmlstr += "</NamePrefix>";
        xmlstr += "<NameSuffix>";
        xmlstr += "</NameSuffix>";
        xmlstr += "<Gender>";
        xmlstr += "</Gender>";
        xmlstr += "<NameStatusCode>";
        xmlstr += "</NameStatusCode>";
        xmlstr += "<NameDatabaseDate>";
        xmlstr += "</NameDatabaseDate>";
        xmlstr += "<FullName>";
        xmlstr += sFullName;
        xmlstr += "</FullName>";
        xmlstr += "</Record>";
        xmlstr += "</RecordSet>";
 return xmlstr;
}





/**
* @param args the command line arguments
* Main function...Sets up JFrame
*/
public static void main (String args[]) 
{

    JFrame frame = new XMLAddress();
    XMLAddress app = new XMLAddress();
    Component contents = app.XMLAddress();
    frame.getContentPane().add(contents, BorderLayout.CENTER);

    //Finish setting up the frame, and show it.
    frame.addWindowListener(new WindowAdapter() 
    {
        public void windowClosing(WindowEvent e) 
        {
            System.exit(0);
        }
    });

    frame.pack();
    frame.setVisible(true);

}

    public void actionPerformed(java.awt.event.ActionEvent actionEvent) 
    {
    }
    

/** 
 * Portions of the following code were taken from a project titled DomEcho02
 * which can be found on the java.sun.com web site. The following disclaimer
 * is included at their request.
 */
    
/*
 * @(#)DomEcho02.java	1.9 98/11/10
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */    
    
    
    
    
static final String[] typeName = 
{
    "none",
    "Element",
    "Attr",
    "Text",
    "CDATA",
    "EntityRef",
    "Entity",
    "ProcInstr",
    "Comment",
    "Document",
    "DocType",
    "DocFragment",
    "Notation",
};
    
public class AdapterNode 
{ 
  org.w3c.dom.Node domNode;

      // An array of names for DOM node-types
    // (Array indexes = nodeType() values.)
 
  // Construct an Adapter node from a DOM node
  public AdapterNode(org.w3c.dom.Node node) 
  {
    domNode = node;
  }

  // Return a string that identifies this node in the tree
  // *** Refer to table at top of org.w3c.dom.Node ***
  public String toString() 
  {
    String s = "";// = typeName[domNode.getNodeType()];
    String nodeName = domNode.getNodeName();
    if (! nodeName.startsWith("#")) 
    {
       s += nodeName;//": " + nodeName;
    }
    if (domNode.getNodeValue() != null) 
    {
       //if (s.startsWith("ProcInstr")) 
       //   s += ", "; 
       //else 
       //   s += ": ";
       // Trim the value to get rid of NL's at the front
       String t = domNode.getNodeValue().trim();
       int x = t.indexOf("\n");
       if (x >= 0) t = t.substring(0, x);
       s += t;
    }
    return s;
  }
  
  
  public int index(AdapterNode child) 
  {
    //System.err.println("Looking for index of " + child);
    int count = childCount();
    for (int i=0; i<count; i++) 
    {
      AdapterNode n = this.child(i);
      if (child == n) return i;
    }
    return -1; // Should never get here.
  }

  public AdapterNode child(int searchIndex) 
  {
    //Note: JTree index is zero-based. 
    org.w3c.dom.Node node = domNode.getChildNodes().item(searchIndex);
    return new AdapterNode(node); 
  }

  public int childCount() 
  {
      return domNode.getChildNodes().getLength();  
  }
} // AdapterNode    


public class DomToTreeModelAdapter implements javax.swing.tree.TreeModel 
{
  // Basic TreeModel operations
  public Object  getRoot() 
  {
    //System.err.println("Returning root: " +document);
    return new AdapterNode(document);
  }
  public boolean isLeaf(Object aNode) 
  {
    // Determines whether the icon shows up to the left.
    // Return true for any node with no children
    AdapterNode node = (AdapterNode) aNode;
    if (node.childCount() > 0) return false;
    return true;
  }
  public int     getChildCount(Object parent) 
  {
    AdapterNode node = (AdapterNode) parent;
    return node.childCount();
  }
  public Object  getChild(Object parent, int index) 
  {
    AdapterNode node = (AdapterNode) parent;
    return node.child(index);
  }
  public int     getIndexOfChild(Object parent, Object child) 
  {
    AdapterNode node = (AdapterNode) parent;
    return node.index((AdapterNode) child);
  }
  public void    valueForPathChanged(TreePath path, Object newValue) 
  {
    // Null. We won't be making changes in the GUI
    // If we did, we would ensure the new value was really new
    // and then fire a TreeNodesChanged event.
  }
      
  private Vector listenerList = new Vector();
  public void addTreeModelListener( TreeModelListener listener ) 
  {
    if ( listener != null && ! listenerList.contains( listener ) ) 
    {
       listenerList.addElement( listener );
    }
  }
  public void removeTreeModelListener( TreeModelListener listener ) 
  {
    if ( listener != null ) 
    {
       listenerList.removeElement( listener );
    }
  }

  public void fireTreeNodesChanged( TreeModelEvent e ) 
  {
    Enumeration listeners = listenerList.elements();
    while ( listeners.hasMoreElements() ) 
    {
      TreeModelListener listener = (TreeModelListener) listeners.nextElement();
      listener.treeNodesChanged( e );
    }
  } 
  public void fireTreeNodesInserted( TreeModelEvent e ) 
  {
    Enumeration listeners = listenerList.elements();
    while ( listeners.hasMoreElements() ) 
    {
       TreeModelListener listener = (TreeModelListener) listeners.nextElement();
       listener.treeNodesInserted( e );
    }
  }   
  public void fireTreeNodesRemoved( TreeModelEvent e ) 
  {
    Enumeration listeners = listenerList.elements();
    while ( listeners.hasMoreElements() ) 
    {
      TreeModelListener listener = (TreeModelListener) listeners.nextElement();
      listener.treeNodesRemoved( e );
    }
  }   
  public void fireTreeStructureChanged( TreeModelEvent e ) 
  {
    Enumeration listeners = listenerList.elements();
    while ( listeners.hasMoreElements() ) 
    {
      TreeModelListener listener = (TreeModelListener) listeners.nextElement();
      listener.treeStructureChanged( e );
    }
  }

 
} // DomToTreeModelAdapter    
    
}


